<?php
	/*
        Effectue le traitement des travaux en queue
		
		Usage :
		run_jobs 
                            
	*/	
    
    $opts = getopt("", array("cfg:", "debug"));

	if (!isset($opts["cfg"]) || empty($opts["cfg"]))
	{
        echo "Usage php ".$argv[0]." --cfg /path/to/config.inc.php directory> [--debug]\n";
        die();
    }
    
	// Autodétection de l'emplacement de Prestashop (attention au lien symbolique sur plateforme de dev)    
	    
	// Inclusion de la configuration
    require($opts["cfg"].'/config.inc.php');		
    require_once( _PS_ROOT_DIR_ . "/modules/polarislink/polarislink.php");  
    require_once( _PS_ROOT_DIR_ . "/modules/polarislink/classes/PolarisLinkSite.php");  
    require_once( _PS_ROOT_DIR_ . "/modules/polarislink/classes/PolarisLinkAPI.php");
	require_once( _PS_ROOT_DIR_ . "/modules/polarislink/classes/PolarisLinkJobManager.php");	
    
	class JobRunner
	{
        private $db;
        private $systemLang;
        private $cfg;

		public function __construct()
		{
            $this->systemLang = Configuration::get('PS_LANG_DEFAULT');
		}
        
        /*
			Importation
		*/
		function run($debug = false)
		{
            // Base de données
            $this->db = Db::getInstance();
            if (!$this->db)
                die ("Erreur d'accès à la base de données");

            // Pas de cache !
            // $this->db->disableCache();

            $this->cfg = PolarisLinkSite::loadConfig();
            
            foreach ($this->cfg as $link)
			{
                if ($debug)
                    echo sprintf("BEGIN %s (%d)\n", $link->LinkName, $link->LinkID);

                $jobsManager = new PolarisLinkJobManager($link);
                if ($debug)
				    $jobsManager->DebugMode = true;
                $jobsManager->run();

                if ($debug)
                    echo sprintf("END %s (%d)\n", $link->LinkName, $link->LinkID);
            }
        }
    }
    
	$runner = new JobRunner();
    $runner->run(isset($opts["debug"]));
